#include <stdint.h>
#include <stdlib.h>
#include <SDL/SDL.h>
#include <SDL/SDL_draw.h>
#include "fxlib.h"
SDL_Surface *DD, *VRAM;
int main(int argc, char **argv)
{
    if(SDL_Init(SDL_INIT_VIDEO) == -1) {
	fprintf(stderr, "Erreur d'initialisation.\n");
	exit(1);
    }
    DD = SDL_SetVideoMode(128, 64, 32, SDL_HWSURFACE);
    VRAM = SDL_CreateRGBSurface(0, 128, 64, 32, 0xFF000000, 0x00FF0000, 0x0000FF00, 0x000000FF);
    if(VRAM == NULL) { fprintf(stderr, "Erreur d'initialisation.\n"); exit(1); }
    AddIn_Main();
    SDL_Quit();
}
void Bdisp_PutDisp_DD(void)
{
    SDL_BlitSurface(VRAM, NULL, DD, NULL);
    SDL_Flip(DD);
}
void Bdisp_AllClr_DD(void)
{
    SDL_FillRect(DD, NULL, 0xFFFFFFFF);
    SDL_Flip(DD);
}
void Bdisp_AllClr_VRAM(void)
{
    SDL_FillRect(VRAM, NULL, 0xFFFFFFFF);
}
void Bdisp_AllClr_DDVRAM(void)
{
    SDL_FlipRect(VRAM,NULL,0xFFFFFFFF);
    SDL_FillRect(DD, NULL, 0xFFFFFFFF);
    SDL_Flip(DD);
}
void Bdisp_AreaClr_DD(const DISPBOX *pArea)
{
    SDL_Rect rect;
    rect.x = pArea->left;
    rect.y = pArea->top;
    rect.w = pArea->right - pArea->left;
    rect.h = pArea->bottom - pArea->top;
    SDL_FillRect(DD, &rect, 0xFFFFFFFF);
    SDL_Flip(DD);
}
void Bdisp_AreaClr_VRAM(const DISPBOX *pArea)
{
    SDL_Rect rect;
    rect.x = pArea->left;
    rect.y = pArea->top;
    rect.w = pArea->right - pArea->left;
    rect.h = pArea->bottom - pArea->top;
    SDL_FillRect(VRAM, &rect, 0xFFFFFFFF);
}
void Bdisp_AreaClr_DDVRAM(const DISPBOX *pArea)
{
    SDL_Rect rect;
    rect.x = pArea->left;
    rect.y = pArea->top;
    rect.w = pArea->right - pArea->left;
    rect.h = pArea->bottom - pArea->top;
    SDL_FillRect(VRAM,&rect,0xFFFFFFFF);
    SDL_FillRect(DD, &rect, 0xFFFFFFFF);
    SDL_Flip(DD);
}
void Bdisp_AreaReverseVRAM(int x1, int y1, int x2, int y2)
{
    int x,y;
    for(x=x1; x<=x2; x++)
	for(y=y1; y<=y2; y++)
	    ((uint32_t *)VRAM->pixels)[y*128+x] ^= 0xFFFFFFFF;
}
void Bdisp_SetPoint_DD(int x,int y,unsigned char point)
{
    ((uint32_t *)DD->pixels)[y*128+x] = (point) ? 0xFFFFFFFF : 0;
    SDL_Flip(DD);
}
void Bdisp_SetPoint_VRAM(int x,int y,unsigned char point)
{
    ((uint32_t *)VRAM->pixels)[y*128+x] = (point) ? 0xFFFFFFFF : 0;
}
void Bdisp_SetPoint_DDVRAM(int x,int y,unsigned char point)
{
    ((uint32_t *)VRAM->pixels)[y*128+x] = (point) ? 0xFFFFFFFF : 0;
    ((uint32_t *)DD->pixels)[y*128+x] = (point) ? 0xFFFFFFFF : 0;
    SDL_Flip(DD);
}
int Bdisp_GetPoint_VRAM(int x,int y)
{
    return (((uint32_t *)VRAM->pixels)[y*128+x] != 0);
}
