#include <fxlib.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "sfc.h"
#include "snowflake.h"
#include "utils.h"
const int basePrices[8] = {15, 100, 500, 3000, 10000, 40000, 200000, 1666666};
int production[8] = {1, 5, 20, 100, 400, 1000, 4000, 66660}; /* Actual production time 10 */
struct Save save;
void drawBitmap()
{
    GRAPHDATA gdata;
    gdata.width = 48;
    gdata.height = 48;
    gdata.pBitmap = snowflake;
    DISPGRAPH dgraph;
    dgraph.x = 1;
    dgraph.y = 0;
    dgraph.GraphData = gdata;
    dgraph.WriteModify = IMB_WRITEMODIFY_NORMAL;
    dgraph.WriteKind = IMB_WRITEKIND_OR;
    Bdisp_WriteGraph_VRAM(&dgraph);
}
int getPrice(int building)
{
    return ((building >= 0) && (building <= 7)) ? (int)((double)basePrices[building] * pow(1.15, save.nb_buildings[building]) * 10) : 0;
}
int addBuilding(int building)
{
    if(save.cookies >= getPrice(building)) {
	save.cookies -= getPrice(building);
	save.nb_buildings[building]++;
	return 0;
    } else {
	return 1;
    }
}
void timerFunction()
{
    save.cookies += getSFPS();
    drawInfo();
    Bdisp_PutDisp_DD();
}
int getSFPS() /* SnowFlakes Per Second */
{
    int i;
    int sfps = 0;
    for(i=0; i<8; i++) {
	sfps += production[i] * save.nb_buildings[i];
    }
    return sfps;
}
int getSFPC() /* SnowFlakes Per Click */
{
    return 10;
}
int click(int choix)
{
    if(choix == 0)
	save.cookies += getSFPC();
    else if(choix > 1) {
	addBuilding(choix - 2);
    }
}
void load()
{
    int fd;
    FONTCHARACTER path[] = {'\\', '\\', 'f', 'l', 's', '0', '\\', 's', 'f', 'c', '.', 's', 'a', 'v', 0};
    fd = Bfile_OpenFile(path, _OPENMODE_READ);
    if(fd < 0) {
	save.cookies = 0;
	memset(save.nb_buildings, 0, 8*sizeof(int));
    } else {
	Bfile_ReadFile(fd, (void *)&save, sizeof(struct Save), -1);
	Bfile_CloseFile(fd);
    }
}
void write()
{
    int fd;
    FONTCHARACTER path[] = {'\\', '\\', 'f', 'l', 's', '0', '\\', 's', 'f', 'c', '.', 's', 'a', 'v', 0};
    Bfile_DeleteFile(path);
    if(Bfile_CreateFile(path, sizeof(struct Save)+1)) {} // Y a un problème si le IF s'active mais je sais pas quoi mettre :P
    fd = Bfile_OpenFile(path, _OPENMODE_WRITE);
    if(fd < 0) {

    } else {
	Bfile_WriteFile(fd, (void *)&save, sizeof(struct Save));
	Bfile_CloseFile(fd);
    }
}
void drawInterface(int choix, int decalage)
{
    char *buffer = malloc(15); int tmp;
    drawBitmap();
    Bdisp_DrawLineVRAM(51, 0, 51, 63);
    Bdisp_DrawLineVRAM(51,18, 127,18);
    Bdisp_DrawLineVRAM(51,27, 127,27);
    Bdisp_DrawLineVRAM(51,36, 127,36);
    Bdisp_DrawLineVRAM(51,45, 127,45);
    Bdisp_DrawLineVRAM(51,54, 127,54);
    Bdisp_DrawLineVRAM(0, 49, 50, 49);
    PrintMini(53, 2 , "Price :", 0);
    PrintMini(53, 11, "Owned :", 0);
    PrintMini(1,51, "SF:", 0);
    PrintMini(1,58, "PS:", 0);
    if(decalage == 0) PrintMini(53, 20, "Upgrades (not yet)", 0);
    if(decalage <= 1) PrintMini(53, 29 - decalage * 9,"Cursor", 0);
    if(decalage <= 2) PrintMini(53, 38 - decalage * 9,"Pif Gadgets", 0);
    if(decalage <= 3) PrintMini(53, 47 - decalage * 9,"Scientists", 0);
    if(decalage <= 4) PrintMini(53, 56 - decalage * 9,"Snow Cannon", 0);
    if(decalage <= 5) PrintMini(53, 65 - decalage * 9,"Ski Resort", 0);
    if(decalage <= 6) PrintMini(53, 74 - decalage * 9,"Stadium", 0);
    if(decalage <= 7) PrintMini(53, 83 - decalage * 9,"Orbit Alteration", 0);
    if(decalage <= 8) PrintMini(53, 92 - decalage * 9,"Temporal Portal",0);
    drawInfo();
    if((choix != 0) && (choix != 1)) {
        itoa(getPrice(choix - 2)/10, buffer); tmp = strlen(buffer);
	PrintMini(80, 2, buffer, 0);
	itoa(getPrice(choix - 2)%10, buffer);
	PrintMini(80 + tmp * 4, 2, ".", 0);
	PrintMini(80 + tmp * 4 + 3, 2, buffer, 0);
	itoa(save.nb_buildings[choix - 2], buffer);
	PrintMini(85, 11, buffer, 0);
    }
    free(buffer);
}
void drawInfo()
{
    char *buffer = malloc(15); int tmp;
    itoa(save.cookies/10, buffer); tmp = strlen(buffer);
    PrintMini(13, 51, buffer, 0);
    itoa(getSFPS()/10, buffer); tmp = strlen(buffer);
    PrintMini(13, 58, buffer, 0);
    itoa(getSFPS()%10, buffer);
    PrintMini(13 + tmp * 4, 58, ".", 0);
    PrintMini(13 + tmp * 4 + 3, 58, buffer, 0);
    free(buffer);
}
void highlight(int choix, int decalage)
{
    if(choix == 0) {
	Bdisp_AreaReverseVRAM(0, 0, 50, 48);
    } else {
	Bdisp_AreaReverseVRAM(52,(choix - decalage + 1) * 9 + 1, 127, (choix - decalage + 2) * 9 - 1);
	if((choix - decalage) == 5) Bdisp_AreaReverseVRAM(52, 63, 127, 63);
    }
}
void startGame()
{
    int key, choix=0, dchoix=1, decalage = 0;
    load();
    SetTimer(1, 1000, timerFunction);
    while(1)
    {
	Bdisp_AllClr_DDVRAM();
	drawInterface(choix, decalage);
	highlight(choix, decalage);
	Bdisp_PutDisp_DD();
	GetKey(&key);
	switch(key) {
	case KEY_CTRL_LEFT:
	    dchoix = (choix != 0) ? choix : dchoix;
	    choix = 0;
	    break;
	case KEY_CTRL_RIGHT:
	    choix = dchoix;
	    break;
	case KEY_CTRL_UP:
	    if(!choix) break;
	    if(choix == 1) { choix = 9; decalage = 4; }
	    else if((choix - decalage) == 1) { choix--; decalage--; }
	    else choix--;
	    break;
	case KEY_CTRL_DOWN:
	    if(!choix) break;
	    if(choix == 9) { choix = 1; decalage = 0; }
	    else if((choix - decalage) == 5) { choix++; decalage++; }
	    else choix++;
	    break;
	case KEY_CTRL_EXE:
	    click(choix);
	    break;
	case KEY_CTRL_MENU:
	case KEY_CTRL_EXIT:
	    KillTimer(1);
	    write();
	    return;
	default:
	    break;
	}
    }
}
